<?php
class ControllerCatalogHiconix extends Controller {
	private $error = array();
	private $logfile = DIR_LOGS . 'hiconix.log';

	public function index() {
		$this->load->language('catalog/hiconix');
		$this->document->setTitle($this->language->get('heading_title'));
		if(($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->load->model('setting/setting');
			$this->model_setting_setting->editSetting('hiconix', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success_save');
		}
		$this->getForm();
	}

	public function load() {
		$this->load->language('catalog/hiconix');
		$this->document->setTitle($this->language->get('heading_title'));
		if(($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->load->model('setting/setting');
			$this->model_setting_setting->editSetting('hiconix', $this->request->post);
			if(file_exists($this->logfile)) {
				$testlog = json_decode( file_get_contents($this->logfile), true );
				if( isset($testlog['code']) && $testlog['code'] != 'ERROR' ) {
					$this->response->redirect($this->url->link('catalog/hiconix', 'token=' . $this->session->data['token'], true));
					return;					
				}
			}
			file_put_contents($this->logfile, json_encode( array('code'=>'LOAD', 'msg'=>'Загрузка брендов. Пожалуйста, подождите. Загрузка бренда занимает до 2-х минут') ) );
			$cmd = 'php ' . DIR_SYSTEM . 'hix_load.php > /dev/null &';
			exec($cmd);
			//require_once DIR_SYSTEM . 'hix_load.php';
		} 
		$this->getForm();
	}

	public function stop(){
		if(file_exists($this->logfile)) {
			unlink($this->logfile);
		}
		$this->session->data['success'] = 'Отдана команда на прекращение загрузки. Пожалуйста, подождите 3 минуты перед тем, как запускать новую сессию.';
		$this->response->redirect($this->url->link('catalog/hiconix', 'token=' . $this->session->data['token'], true));
	}

	public function remove() {
		$this->load->language('catalog/hiconix');
		$tmp = $this->db->query("
			SELECT `product_id` AS pid FROM `" . DB_PREFIX . "product`
			WHERE `hix_pid` > 0
		");
		$this->db->query("
			DELETE FROM `" . DB_PREFIX . "product`
			WHERE `hix_pid` > 0
		");
		foreach($tmp->rows as $prod) {
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "product_description`
				WHERE `product_id` = " . (int)$prod['pid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "product_image`
				WHERE `product_id` = " . (int)$prod['pid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "product_attribute`
				WHERE `product_id` = " . (int)$prod['pid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "product_to_category`
				WHERE `product_id` = " . (int)$prod['pid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "product_to_store`
				WHERE `product_id` = " . (int)$prod['pid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "url_alias`
				WHERE `query` = 'product_id=" . (int)$prod['pid'] . "'
			");
		}
		$tmp = $this->db->query("
			SELECT `category_id` AS cid FROM `" . DB_PREFIX . "category`
			WHERE `hix_cid` > 0
		");
		$this->db->query("
			DELETE FROM `" . DB_PREFIX . "category`
			WHERE `hix_cid` > 0
		");
		foreach($tmp->rows as $cat) {
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "category_description`
				WHERE `category_id` = " . (int)$cat['cid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "category_to_store`
				WHERE `category_id` = " . (int)$cat['cid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "url_alias`
				WHERE `query` = 'category_id=" . (int)$cat['cid'] . "'
			");
		}
		$tmp = $this->db->query("
			SELECT `manufacturer_id` AS mid FROM `" . DB_PREFIX . "manufacturer`
			WHERE `hix_mid` > 0
		");
		$this->db->query("
			DELETE FROM `" . DB_PREFIX . "manufacturer`
			WHERE `hix_mid` > 0
		");
		foreach($tmp->rows as $man) {
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "manufacturer_description`
				WHERE `manufacturer_id` = " . (int)$man['mid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "manufacturer_to_store`
				WHERE `manufacturer_id` = " . (int)$man['mid'] . "
			");
			$this->db->query("
				DELETE FROM `" . DB_PREFIX . "url_alias`
				WHERE `query` = 'manufacturer_id=" . (int)$man['mid'] . "'
			");
		}
		$this->load->model('catalog/category');
		$this->model_catalog_category->repairCategories();
		$this->session->data['success'] = $this->language->get('text_success_delete');
		$this->response->redirect($this->url->link('catalog/hiconix', 'token=' . $this->session->data['token'], true));
	}

	public function getlog() {
		if(file_exists($this->logfile)) {
			$content = file_get_contents($this->logfile);
			$test = json_decode($content, true);
			if($test['code'] == 'ERROR' || $test['code'] == 'COMPLETE') unlink($this->logfile);
			if(isset($test['percent'])) {
				$test['msg'] .= '<div style="border:1px solid black;background:white;width:300px;margin-top:10px"><div style="width:' . $test['percent'] . 
									'%;background:#0A0;height:20px"></div></div>';
				$content = json_encode($test);
			}
		} else {
			$content = json_encode( array('code'=>'NOFILE') );
		}
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput($content);
	}

	protected function getForm() {
		if(file_exists($this->logfile)) {
			$data['stopclass'] = ' active';
		} else {
			$data['stopclass'] = '';
		}

		$this->document->addStyle('view/stylesheet/hiconix.css');
		
		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_load'] = $this->language->get('text_load');

		$data['text_default'] = $this->language->get('text_default');

		$data['entry_token'] = $this->language->get('entry_token');
        $data['entry_prefixname'] = $this->language->get('entry_prefixname');
		
		$data['entry_load'] = $this->language->get('entry_load');
		$data['entry_update'] = $this->language->get('entry_update');
		$data['entry_update_price'] = $this->language->get('entry_update_price');
		$data['entry_update_seo'] = $this->language->get('entry_update_seo');
		$data['entry_update_desc'] = $this->language->get('entry_update_desc');
		$data['entry_update_cats'] = $this->language->get('entry_update_cats');
		
		$data['entry_brand'] = $this->language->get('entry_brand');
		$data['entry_brand_name'] = $this->language->get('entry_brand_name');
		$data['entry_brand_category'] = $this->language->get('entry_brand_category');
		$data['entry_brand_loadcats'] = $this->language->get('entry_brand_loadcats');
		
		$data['entry_attr'] = $this->language->get('entry_attr');
		$data['entry_attr_src'] = $this->language->get('entry_attr_src');
		$data['entry_attr_targ'] = $this->language->get('entry_attr_targ');
		$data['entry_attr_unit'] = $this->language->get('entry_attr_unit');
		
		$data['entry_store'] = $this->language->get('entry_store');

		$data['help_attr_targ'] = $this->language->get('help_attr_targ');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_delete'] = $this->language->get('button_delete');

		$data['attr_code'] = $this->language->get('attr_code');
		$data['attr_teaser'] = $this->language->get('attr_teaser');
		$data['attr_coolpower'] = $this->language->get('attr_coolpower');
		$data['attr_heatpower'] = $this->language->get('attr_heatpower');
		$data['attr_coolnetpower'] = $this->language->get('attr_coolnetpower');
		$data['attr_heatnetpower'] = $this->language->get('attr_heatnetpower');
		$data['attr_inverter'] = $this->language->get('attr_inverter');
		$data['attr_energyeff'] = $this->language->get('attr_energyeff');
		$data['attr_noise_indoor'] = $this->language->get('attr_noise_indoor');
        $data['attr_noise_outdoor'] = $this->language->get('attr_noise_outdoor');
		$data['attr_indoortype'] = $this->language->get('attr_indoortype');
		$data['attr_squaremeters'] = $this->language->get('attr_squaremeters');
		$data['attr_gas_tube_diam'] = $this->language->get('attr_gas_tube_diam');
		$data['attr_liquid_tube_diam'] = $this->language->get('attr_liquid_tube_diam');
		$data['attr_max_bus_length'] = $this->language->get('attr_max_bus_length');
		$data['attr_country'] = $this->language->get('attr_country');
		$data['attr_warranty'] = $this->language->get('attr_warranty');
		$data['attr_length_width_height_indoor'] = $this->language->get('attr_length_width_height_indoor');
        $data['attr_length_width_height_outdoor'] = $this->language->get('attr_length_width_height_outdoor');
		$data['attr_weight_indoor'] = $this->language->get('attr_weight_indoor');
        $data['attr_weight_outdoor'] = $this->language->get('attr_weight_outdoor');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('catalog/hiconix', 'token=' . $this->session->data['token'], true)
		);

		$data['action_save'] = $this->url->link('catalog/hiconix', 'token=' . $this->session->data['token'], true);
		$data['action_load'] = str_replace( '&amp;', '&', $this->url->link('catalog/hiconix/load', 'token=' . $this->session->data['token'], true) );
		$data['getlog'] = str_replace( '&amp;', '&', $this->url->link('catalog/hiconix/getlog', 'token=' . $this->session->data['token'], true) );
		$data['action_delete'] = str_replace( '&amp;', '&', $this->url->link('catalog/hiconix/remove', 'token=' . $this->session->data['token'], true) );
		$data['action_stop'] = str_replace( '&amp;', '&', $this->url->link('catalog/hiconix/stop', 'token=' . $this->session->data['token'], true) );

		$data['cancel'] = $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true);

		$data['token'] = $this->session->data['token'];

		$this->load->model('setting/store');
		$data['stores'] = $this->model_setting_store->getStores();
		array_unshift($data['stores'], array('store_id'=>0, 'name'=>$this->config->get('config_name')));
		
		$this->load->model('catalog/category');
		$categories = $this->model_catalog_category->getAllCategories();
		$data['categories'] = array();

		if( isset($this->request->get['store']) ) {
			$data['current_store'] = (int)$this->request->get['store'];
		} else {
			$data['current_store'] = (int)$this->config->get('config_store_id');
		}
		if( !empty($categories[0]) ) {
			foreach($categories[0] as $topcat) {
				if($topcat['store_id'] != $data['current_store']) {
					continue;
				} 
				$data['categories'][$topcat['category_id']] = $topcat['name'];
			}
		}

		$this->load->model('catalog/attribute');
		$attributes = $this->model_catalog_attribute->getAttributes();
		$data['attributes'] = array();
		if($attributes) {
			foreach($attributes as $attr) {
				$data['attributes'][$attr['attribute_id']] = $attr['name'];
			}
		}
		// Settings
		$settings = $this->config->get('hiconix_settings');
		if( isset($this->request->post['hiconix_settings']) ) {
			$data['settings'] = $this->request->post['hiconix_settings'];
		} elseif($settings) {
			$data['settings'] = $settings;
		} else {
			$data['settings'] = array();
		}

		if(!isset($data['settings']['token'])) {
			$data['settings']['token'] = '';
		}

		if(!isset($data['settings']['brands'])) {
			$data['settings']['brands'] =  array(
				array(
					'category' => 0
				),
				array(
					'category' => 0
				),
				array(
					'category' => 0
				)
			);
			$data['settings']['update_price'] = 1;
			$data['settings']['update_seo'] = 1;
		}

		if(!isset($data['settings']['attributes'])) {
			$data['settings']['attributes'] =  array(
					'coolpower' => array( 'map' => 0, 'unit' => 'кВт', 'update'=>1),
					'heatpower' => array( 'map' => 0, 'unit' => 'кВт', 'update'=>1),
					'coolnetpower' => array( 'map' => 0, 'unit' => 'кВт', 'update'=>1),
					'heatnetpower' => array( 'map' => 0, 'unit' => 'кВт', 'update'=>1),
					'inverter' => array( 'map' => 0, 'unit' => '', 'update'=>1),
					'energyeff' => array( 'map' => 0, 'unit' => '', 'update'=>1),
					'noise_indoor' => array( 'map' => 0, 'unit' => '', 'update'=>1),
                    'noise_outdoor' => array( 'map' => 0, 'unit' => '', 'update'=>1),
					'indoortype' => array( 'map' => 0, 'unit' => '', 'update'=>1),
					'squaremeters' => array( 'map' => 0, 'unit' => '', 'update'=>1),
					'length_width_height_indoor' => array( 'map' => 0, 'unit' => 'мм', 'update'=>1),
                    'length_width_height_outdoor' => array( 'map' => 0, 'unit' => 'мм', 'update'=>1),
					'gas_tube_diam' => array( 'map' => 0, 'unit' => 'мм', 'update'=>1),
					'liquid_tube_diam' => array( 'map' => 0, 'unit' => 'мм', 'update'=>1),
					'max_bus_length' => array( 'map' => 0, 'unit' => 'мм', 'update'=>1),
					'country' => array( 'map' => 0, 'unit' => '', 'update'=>1),
					'warranty' => array( 'map' => 0, 'unit' => '', 'update'=>1),
					'weight_indoor' => array( 'map' => 0, 'unit' => 'кг', 'update'=>1),
                    'weight_outdoor' => array( 'map' => 0, 'unit' => 'кг', 'update'=>1),
					'width_length_height_indoor' => array( 'map' => 0, 'unit' => 'мм', 'update'=>1),
                    'width_length_height_outdoor' => array( 'map' => 0, 'unit' => 'мм', 'update'=>1),
					'code' => array( 'map' => 0, 'unit' => '', 'update'=>1),
					'teaser' => array( 'map' => 0, 'unit' => '', 'update'=>1)
			);
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('catalog/hiconix', $data));
	}

	protected function validateForm() {
		if (!$this->user->hasPermission('modify', 'catalog/hiconix')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		if( empty($this->request->post['hiconix_settings']['token']) ) {
			$this->error['warning'] = $this->language->get('error_token');
		}

		$nobrands = true;
		foreach($this->request->post['hiconix_settings']['brands'] as $brand) {
			if(!empty($brand['load'])) {
				$nobrands = false;
			}
		}

		if( $nobrands ) {
			if(isset($this->error['warning'])) {
				$this->error['warning'] .= ' ' . $this->language->get('error_brands');
			} else {
				$this->error['warning'] = $this->language->get('error_brands');
			}
		}

		return !$this->error;
	}
}