<?php
require_once '../config.php';
require_once DIR_SYSTEM . 'library/db.php';
require_once DIR_SYSTEM . 'library/db/mysqli.php';

$db = new DB(DB_DRIVER, DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE, DB_PORT);

function log_error( $num, $str, $file, $line, $context = null ) {
    log_exception( new ErrorException( $str, 0, $num, $file, $line ) );
}

function log_exception( $e ) {
	$report = array('code'=>'ERROR');
	$report['msg'] = $e->getMessage();
	//file_put_contents(DIR_LOGS . 'hiconix.log', json_encode($report));
    //exit();
}

function check_for_fatal() {
    $error = error_get_last();
    if ( $error["type"] == E_ERROR ) {
        log_error( $error["type"], $error["message"], $error["file"], $error["line"] );
    }
}

register_shutdown_function( "check_for_fatal" );
set_error_handler( "log_error" );
set_exception_handler( "log_exception" );
ini_set( "display_errors", "off" );
error_reporting(0);
set_time_limit(0);

require_once DIR_SYSTEM . 'library/hiconix.php';
$HIX = new Hiconix($db);
$HIX->doLoad();